module Optimize(optimize) where

import AST
import Rewrite 
import Redundancy
import EMElimination
import PushSpaces
import SizeColor

optimize :: Doc -> Doc
optimize = 
           removeEM 
         . runRewrite 
         . optColors 
         . optSizes 
         . pushSpaces 
         . optimizeRedundancy 

-- optimize = runRewrite 
-- optimize = id
