HC        = ghc
HC_DEP    = ${HC} -M
HC_INCI   = ${addprefix -i,${HC_INC}}
HC_PKGI   = ${addprefix -package ,${HC_PKG}}
HC_LIBI   = ${addprefix -l,${HC_LIBS}}
HC_OPTS   = ${$*_HC_OPTS} ${HC_XOPTS} ${HC_INCI} ${HC_PKGI}
HC_LDOPTS = ${HC_OPTS} ${addprefix -L,${HC_INC}} ${HC_LIBI} -optl -static
STD_CLEAN = .\#* *~ *.a *.o *.hi 

%.o : %.hs
	${HC} ${HC_WOPTS} ${HC_OPTS} -c ${<} -o $@ 
 
%.hi : %.o
	@if [ ! -f $@ ] ; then \
	    echo Panic! $< exists, but $@ does not. \
	    exit 1; \
	else exit 0 ; \
	fi
 
depend: .depend
 
.depend: ${HC_SRC}                         
	${HC_DEP} -optdep-f -optdep.depend ${HC_OPTS} ${HC_SRC}                 
